-- DaemonMailAssist -- By Raum of Hyjal - Originally by Jeremy (Daemon) Reed
RMA = LibStub("AceAddon-3.0"):NewAddon("DaemonMailAssist", "AceEvent-3.0", "AceConsole-3.0" )
RMA_VERSION =   GetAddOnMetadata("DaemonMailAssist", "Version");
RMA_TITLE = "DMA";
RMA_DEBUG = false;
RMA_IS_LOADED = false;
MAX_RECENT = 35

IndexBoxes = {};
GetEverything = false


LABEL_FONTSTRING_SUFFIX = "Label";

RMA_RECENTS = {};

MAIL_QUEUE = {};
MAIL_QUEUE_ITEMS = 0;
MAIL_PROCESSING = false;
MAIL_PAUSE = false;

function RMA:Print(input,...)   print('|cffffff78Daemon Mail Assist:|r '..input) end
function RMA:DebugPrint(input,...) if ( RMA_DEBUG ) then print('|cffffff78DMA Debug:|r '..input) end end

function RMA:OnEnable()
    RMA:Print("Addon Loaded!")
  RMA:RegisterEvent("MAIL_SHOW");
  RMA:RegisterEvent("MAIL_CLOSED");
  RMA:RegisterEvent("MAIL_INBOX_UPDATE");
  RMA:RegisterEvent("PLAYER_MONEY");
  RMA:RegisterEvent("ITEM_PUSH");
  RMA:RegisterEvent("LOOT_OPENED");
  RMA:RegisterEvent("LOOT_CLOSED");

    RMA:RegisterChatCommand("DMA", "ChatCommand")
    RMA:RegisterChatCommand("DaemonMail", "ChatCommand")
    RMA:RegisterChatCommand("DaemonMailAssist", "ChatCommand")
    hooksecurefunc("InboxFrame_Update", RMA_InboxUpdate);
    RMA_ShowIndexBoxes()
end

function RMA:ChatCommand(input)
local bad = "Valid Options are: <debug> <reset>";
    if not input or input:trim() == "" then
        RMA:Print(bad)
        return
    end

     if input:trim() == "reset" then
        GetEverything = false;
        MAIL_QUEUE = {};
        MAIL_QUEUE_ITEMS = 0;
        MAIL_PROCESSING = false;
        return
     end
     
    if input:trim() == "debug" then
        RMA:Print("Debug messages now showing.")
        RMA_DEBUG = true;
        return
    end
    
      RMA:Print(bad)
      return
end


function RMA:MAIL_SHOW(event, ...)  
    RMA:DebugPrint("Mail Show .. Firing.")
    CheckInbox();
end


function RMA:MAIL_INBOX_UPDATE(event, ...)  
    RMAInbox_ShowInboxInfo()
    RMAInbox_PopulateDropDown()
end

function RMA:LOOT_OPENED(event,...)
    MAIL_PAUSE = true;
end

function RMA:LOOT_CLOSED(event,...)
    MAIL_PAUSE = false;
     if(MAIL_PROCESSING == true) then RMAMail_ProcessQueue();  end
end
  
function RMA:PLAYER_MONEY(event, ...)
  if(MAIL_PROCESSING == true) then
    RMAMail_ProcessQueue();  
  end
end


function RMA:ITEM_PUSH(event, ...)
  if(MAIL_PROCESSING == true) then
        RMAMail_ProcessQueue();  
   end
end

function RMA:MAIL_CLOSED(event, ...)
    for i = 1, GetInboxNumItems() do
		if not select(9, GetInboxHeaderInfo(i)) then return end
	end
	MiniMapMailFrame:Hide()
end


function Label(name)
  return getglobal(name.."Label");
end

function SetLabelText(labelName,msg)
  getglobal(labelName..LABEL_FONTSTRING_SUFFIX):SetText(msg);
end

function IsFrameDisplayed(frame)
  local shown = frame:IsShown();
  local visible = frame:IsVisible();
  
  if(shown == 1 and visible == 1) then
    return true;
  else
    return false;
  end
end


function RMAFriends_GetFriends()
  local friendCount = GetNumFriends();
  local FRIENDS = {};
  local FRIENDS_COUNT = 0;
  
  if(friendCount == nil) then
    return nil;
  end
  if(friendCount == 0) then
    return nil;
  end
  
  for i=1, friendCount do
    name, level, class, area, connected, status, note = GetFriendInfo(i);
    if(name ~= nil) then
      FRIENDS[FRIENDS_COUNT] = {};
      FRIENDS[FRIENDS_COUNT]["name"] = name;
      FRIENDS[FRIENDS_COUNT]["online"] = connected;
      FRIENDS_COUNT = FRIENDS_COUNT + 1;
    end
  end

  table.sort(FRIENDS,RMAFriends_Sort);
  table.sort(FRIENDS,RMAFriends_Sort);
  
  return FRIENDS;
  
end

function RMAFriends_Sort(a,b)
  return a.name < b.name;
end

function RMAGuild_GetMembers()
  local memberCount = GetNumGuildMembers(true);
  local GUILD_MEMBERS = {};
  local GUILD_MEMBERS_COUNT = 0;
  
  if(memberCount == nil) then
    return nil;
  end
  if(memberCount == 0) then
    return nil;
  end

  for i=1, memberCount do
    name, rank, rankIndex, level, class, zone, note,   officernote, online, status = GetGuildRosterInfo(i);
    if(name ~= nil) then 
      GUILD_MEMBERS[GUILD_MEMBERS_COUNT] = {};
      GUILD_MEMBERS[GUILD_MEMBERS_COUNT]["name"] = name;
      GUILD_MEMBERS[GUILD_MEMBERS_COUNT]["online"] = online;
      GUILD_MEMBERS_COUNT = GUILD_MEMBERS_COUNT + 1;
    end
  end
  
    table.sort(GUILD_MEMBERS,RMAGuild_Sort);
    --table.sort(GUILD_MEMBERS,RMAGuild_Sort);
  
  
  return GUILD_MEMBERS;
end


function RMAGuild_Sort(a,b)
  return a.name < b.name;
end

function RMARecents_Add(cname)
  local nameFound = false;
  
  if(cname == nil) then 
    return;
  end
  
  if(RMA_RECENTS == nil) then 
    RMA_RECENTS = {}; 
  end
  
  for i=0, #RMA_RECENTS do
    if(RMA_RECENTS[i] == cname) then
      nameFound = true;
    end    
  end
  
  if(nameFound == false) then
    --RMA_RECENTS[#RMA_RECENTS + 1] = cname;
    table.insert(RMA_RECENTS,0,cname);
  end
  
  RMARecents_Filter();

end

function RMARecents_Get()
  if(RMA_RECENTS == nil) then RMA_RECENTS = {}; end
  return RMA_RECENTS;
end

function RMARecents_Sort(a,b)
  return a < b;
end

function RMARecents_Filter()
  local counter = 0;
  while #RMA_RECENTS > MAX_RECENT do
    table.remove(RMA_RECENTS,#RMA_RECENTS);
    counter = counter + 1;
    if(counter > 100) then
      return;
    end
  end
end


function RMAMail_GetMoneyCount()
  local amount = 0;
  local iG = 0;
  local iS = 0;
  local iC = 0;
  local COD = 0;
  local Items = 0;
  
  for i=GetInboxNumItems(),1, -1  do
    packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead,     wasReturned, textCreated, canReply, isGM = GetInboxHeaderInfo(i);
    if CODAmount > 1 then COD = COD + CODAmount; end
    
    if hasItem then Items = Items + hasItem;  end
    if(money ~= nil) then
      if(money > 0) then
        amount = amount + money;
      end
    end
    
  end

  local msg = "";

  if(amount > 0) then
    iG = (amount / 10000);
    iS = (iG - math.floor(iG)) * 100;
    iC = (iS - math.floor(iS)) * 100;
    iG = math.floor(iG);
    iS = math.floor(iS);
    iC = math.ceil(iC);

    return iG, iS, iC, COD, Items;
  else
    return 0,0,0, COD, Items;
  end
end

function RMAMail_GetNewCount()
  local newCount = 0;
  for i=GetInboxNumItems(),1, -1  do
    packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead,     wasReturned, textCreated, canReply, isGM = GetInboxHeaderInfo(i);
    if(wasRead == nil) then
      newCount = newCount + 1;
    end
  end
  return newCount;
end

function RMAMail_GetSenders()
  local tbl = {};
  local tblIndex = 0;
 
  for i=GetInboxNumItems(),1, -1  do
    packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead,     wasReturned, textCreated, canReply, isGM = GetInboxHeaderInfo(i);
    senderFound = false;


   
    for j=0, #tbl do
      if(tbl[j] == sender) then
        senderFound = true;
      end
    end
    if(senderFound == false) then
      --RMA:DebugPrint("Found Sender : "..sender)
      tbl[tblIndex] = sender;
      tblIndex = tblIndex + 1;
    end
  end
  
  --table.sort(tbl);
  
  return tbl;
end

function RMAMail_GetInboxInfo()
--RMA:DebugPrint("Loading Inbox info");
  local info = {};
  info["messages"] = GetInboxNumItems();
  info["senders"] = RMAMail_GetSenders();
  info["newMail"] = HasNewMail();
  info["newCount"] = RMAMail_GetNewCount();
  info["gold"], info["silver"], info["copper"], info["cod"], info["items2"] = RMAMail_GetMoneyCount();
  info["items"] = {};
    
  return info;
end

function RMAMail_StartProcessQueue()
  RMA:DebugPrint("Start Process Queue");
  MAIL_PAUSE = false;
  MAIL_PROCESSING = true;
  RMAMail_ProcessQueue();
end

function RMAMail_EndProcessQueue()
  RMA:DebugPrint("End Process Queue");
  MAIL_QUEUE = {};
  MAIL_QUEUE_ITEMS = 0;
  MAIL_PROCESSING = false;
  GetEverything = false;
  RMAInbox_ShowInboxInfo();
end


function RMAMail_PrintQueue()

  if(MAIL_QUEUE == nil) then
    MAIL_QUEUE = {};
    MAIL_QUEUE_ITEMS = 0;
    MAIL_PROCESSING = false;
    Print("Queue Empty",1,.5,.5);
    return;
  end
  
  for i=0, MAIL_QUEUE_ITEMS do
    if(MAIL_QUEUE[i] ~= nil) then
      Print(MAIL_QUEUE[i]["type"] .. ", " .. MAIL_QUEUE[i]["inboxIndex"] .. ", " .. MAIL_QUEUE[i]["itemIndex"], 1, .5, .5);
    end
  end
end
 
function RMAMail_QueueGrabSender(senderName, getItems, getMoney, payCOD)
  MAIL_QUEUE = {};
  MAIL_QUEUE_ITEMS = 0;
  
  --RMA:DebugPrint("Start QueueGrabSender");
  
  for i=GetInboxNumItems(),1, -1  do
    packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, hasItem, wasRead,     wasReturned, textCreated, canReply, isGM = GetInboxHeaderInfo(i);
  
  
    if((GetEverything == true and IndexBoxes[i] ) or (GetEverything == false and (sender == senderName or senderName == "All"))) then
      RMA:DebugPrint("Grabbing #"..i.." : "..subject);
      if ( IndexBoxes[i] ) then IndexBoxes[i] = nil end
      if(getMoney == true) then
        if(money ~= nil) then
          if(money > 0) then
            MAIL_QUEUE[MAIL_QUEUE_ITEMS] = {};
            MAIL_QUEUE[MAIL_QUEUE_ITEMS]["type"] = "MONEY";
            MAIL_QUEUE[MAIL_QUEUE_ITEMS]["inboxIndex"] = i;
            MAIL_QUEUE[MAIL_QUEUE_ITEMS]["itemIndex"] = 0;
            MAIL_QUEUE[MAIL_QUEUE_ITEMS]["processed"] = false;
            MAIL_QUEUE_ITEMS = MAIL_QUEUE_ITEMS + 1;
          end
        end
      end
    
      if(getItems == true) then
        if(hasItem ~= nil  and ( CODAmount == 0 or payCOD == TRUE ) ) then
          for j=hasItem, 1, -1 do
            cname, citemTexture, ccount, cquality, ccanUse = GetInboxItem(i, j);
            if(cname ~= nil) then
              MAIL_QUEUE[MAIL_QUEUE_ITEMS] = {};
              MAIL_QUEUE[MAIL_QUEUE_ITEMS]["type"] = "ITEM";
              MAIL_QUEUE[MAIL_QUEUE_ITEMS]["inboxIndex"] = i;
              MAIL_QUEUE[MAIL_QUEUE_ITEMS]["itemIndex"] = j;
              MAIL_QUEUE[MAIL_QUEUE_ITEMS]["processed"] = false;
              MAIL_QUEUE_ITEMS = MAIL_QUEUE_ITEMS + 1;
            end
          end
        end
      end
     
      
    end
    
  end
  
  RMA:DebugPrint("End QueueGrabSender: ".. MAIL_QUEUE_ITEMS);

end

function RMAMail_ProcessQueue()
  if MAIL_PAUSE == true then RMA:DebugPrint("Pausing due to loot ...") return end
  
  RMA:DebugPrint("ProcessQueue");
  
  if(MAIL_PROCESSING == false) then
    RMA:DebugPrint("MAIL_PROCESSING is false");
    return;
  end
  
  if(MAIL_QUEUE == nil) then
    RMA:DebugPrint("MAIL_QUEUE is nil");
    MAIL_QUEUE = {};
    MAIL_QUEUE_ITEMS = 0;
    MAIL_PROCESSING = false;
    return;
  end
  
  for i=0, MAIL_QUEUE_ITEMS do
    if(MAIL_QUEUE[i] ~= nil) then
      if(MAIL_QUEUE[i]["processed"] == false) then
        MAIL_QUEUE[i]["processed"] = true;
        if(MAIL_QUEUE[i]["type"] == "ITEM") then
          RMA:DebugPrint("Taking Inbox Item");
          TakeInboxItem(MAIL_QUEUE[i]["inboxIndex"],MAIL_QUEUE[i]["itemIndex"]);
          return;
        elseif(MAIL_QUEUE[i]["type"] == "MONEY") then
          RMA:DebugPrint("Taking Money");
          TakeInboxMoney(MAIL_QUEUE[i]["inboxIndex"]); 
          return;
        end
      end
    end
  end
  
  RMA:DebugPrint("Queue done");
  GetEverything = false;
  RMAInbox_ShowInboxInfo();
  MAIL_QUEUE = {};
  MAIL_QUEUE_ITEMS = 0;
  MAIL_PROCESSING = false;
end

