﻿
local SendMailFunc = SendMailFrame_SendMail;

function RMAOutbox_OnLoad()
  RMAOutbox:SetParent(SendMailFrame);
  RMAOutbox:RegisterEvent("ADDON_LOADED");
  RMAOutbox:RegisterEvent("MAIL_SHOW");
  RMAOutbox:RegisterEvent("MAIL_CLOSED");
  RMAOutbox:RegisterEvent("MAIL_SEND_INFO_UPDATE");
  RMAOutbox:RegisterEvent("UPDATE_PENDING_MAIL");
  RMAOutbox:RegisterForDrag("LeftButton");
end

function RMAOutbox_OnEvent()
  
end

function SendMailFrame_SendMail()
  RMARecents_Add(SendMailNameEditBox:GetText());
  RMAOutbox_GetRecents();
  SendMailFunc();
end

function RMAOutbox_GetGuildMembers()
  local senders = RMAGuild_GetMembers();
  
  if(senders == nil) then
    return;
  end
  
  RMAScroll_Init(txtGuild, slGuild);
  
  for i=1, #senders do
    local pmsg = "";
    pmsg = "|H" .. senders[i]["name"] .. "|h" .. senders[i]["name"] .. "|h";
    if(senders[i]["online"] == nil) then
      RMAScroll_AddMessage(txtGuild, slGuild, pmsg, .80, .80, .80);
    else
      RMAScroll_AddMessage(txtGuild, slGuild, pmsg, .65, 1, .65);
    end
    
  end
  
  RMAScroll_ScrollToTop(txtGuild, slGuild);
end

function RMAOutbox_GetFriends()
  local senders = RMAFriends_GetFriends();
  
  if(senders == nil) then
    return;
  end
  
  RMAScroll_Init(txtFriends, slFriends);
  
  for i=0, #senders do
    local pmsg = "";
    pmsg = "|H" .. senders[i]["name"] .. "|h" .. senders[i]["name"] .. "|h";
    if(senders[i]["online"] == nil) then
      RMAScroll_AddMessage(txtFriends, slFriends, pmsg, .80, .80, .80);
    else
      RMAScroll_AddMessage(txtFriends, slFriends, pmsg, .65, 1, .65);
    end
    
  end
  
  RMAScroll_ScrollToTop(txtFriends, slFriends);
end

function RMAOutbox_GetRecents()
  local senders = RMARecents_Get();

  if(senders == nil) then
    return;
  end
  
  RMAScroll_Init(txtRecent, slRecent);
  
  for i=0, #senders do
    if(senders[i] ~= nil) then
      local pmsg = "";
      pmsg = "|H" .. senders[i] .. "|h" .. senders[i] .. "|h";
      RMAScroll_AddMessage(txtRecent, slRecent, pmsg, .80, .80, .80);
    end
  end
  
  RMAScroll_ScrollToTop(txtRecent, slRecent);
end


function RMAScroll_Init(objScroll, objSlider)
  objScroll:Clear();
  objScroll:ScrollToTop();
  objSlider:SetMinMaxValues(0,0);
  objSlider:SetValue(0);
end

function RMAScroll_Scroll(objScroll, objSlider, dir)
  local step = 1;
    
  if(dir == 1) then
    objScroll:ScrollDown();
    objSlider:SetValue(objSlider:GetValue() + step);  
  else
    objScroll:ScrollUp();
    objSlider:SetValue(objSlider:GetValue() - step);  
  end
  
end

function RMAScroll_ScrollToTop(objScroll, objSlider)
  
  objScroll:ScrollToTop();  
  
  for i=1, (objScroll:GetNumMessages()-1) do
    objScroll:ScrollDown();
  end
  
  objSlider:SetMinMaxValues(objScroll:GetNumLinesDisplayed(),objScroll:GetNumMessages());
  objSlider:SetValue(objScroll:GetNumLinesDisplayed());
end

function RMAScroll_OnValueChanged(objScroll, objSlider)
 if objScroll then
  objScroll:ScrollToTop();
  for i=2, math.floor(objSlider:GetValue()) do
    objScroll:ScrollDown();
  end
 end
end

function RMAScroll_AddMessage(objScroll, objSlider, strText, r, g, b)
  objScroll:AddMessage(strText,r,g,b);
end

function RMAScroll_MsgOnMouseWheel(objScroll, objSlider, direct)
  RMAScroll_Scroll(objScroll, objSlider, -direct)
end

